src/Entity/Decret.php
<?php

namespace App\Entity;

use App\Repository\DecretRepository;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=DecretRepository::class)
 */
class Decret
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $titre;

    /**
     * @ORM\Column(type="text")
     */
    private $contenu;

    /**
     * @ORM\Column(type="datetime")
     */
    private $date_insert;

    /**
     * @ORM\Column(type="datetime", nullable=true)
     */
    private $date_update;

    /**
     * @ORM\Column(type="datetime", nullable=true)
     */
    private $date_apply;

    /**
     * @ORM\Column(type="datetime", nullable=true)
     */
    private $date_close;

    /**
     * @ORM\Column(type="string", length=1)
     */
    private $actif;

    /**
     * @ORM\ManyToOne(targetEntity=Instance::class, inversedBy="decrets")
     * @ORM\JoinColumn(nullable=false)
     */
    private $id_instance;

    /**
     * @ORM\ManyToOne(targetEntity=Personne::class, inversedBy="decrets")
     */
    private $auteur;

    /**
     * @ORM\ManyToOne(targetEntity=Personne::class, inversedBy="decrets_reformes")
     */
    private $editeur;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitre(): ?string
    {
        return $this->titre;
    }

    public function setTitre(string $titre): self
    {
        $this->titre = $titre;

        return $this;
    }

    public function getContenu(): ?string
    {
        return $this->contenu;
    }

    public function setContenu(string $contenu): self
    {
        $this->contenu = $contenu;

        return $this;
    }

    public function getDateInsert(): ?\DateTimeInterface
    {
        return $this->date_insert;
    }

    public function setDateInsert(\DateTimeInterface $date_insert): self
    {
        $this->date_insert = $date_insert;

        return $this;
    }

    public function getDateUpdate(): ?\DateTimeInterface
    {
        return $this->date_update;
    }

    public function setDateUpdate(?\DateTimeInterface $date_update): self
    {
        $this->date_update = $date_update;

        return $this;
    }

    public function getDateApply(): ?\DateTimeInterface
    {
        return $this->date_apply;
    }

    public function setDateApply(?\DateTimeInterface $date_apply): self
    {
        $this->date_apply = $date_apply;

        return $this;
    }

    public function getDateClose(): ?\DateTimeInterface
    {
        return $this->date_close;
    }

    public function setDateClose(?\DateTimeInterface $date_close): self
    {
        $this->date_close = $date_close;

        return $this;
    }

    public function getActif(): ?string
    {
        return $this->actif;
    }

    public function setActif(string $actif): self
    {
        $this->actif = $actif;

        return $this;
    }

    public function getIdInstance(): ?Instance
    {
        return $this->id_instance;
    }

    public function setIdInstance(?Instance $id_instance): self
    {
        $this->id_instance = $id_instance;

        return $this;
    }

    public function getAuteur(): ?Personne
    {
        return $this->auteur;
    }

    public function setAuteur(?Personne $auteur): self
    {
        $this->auteur = $auteur;

        return $this;
    }

    public function getEditeur(): ?Personne
    {
        return $this->editeur;
    }

    public function setEditeur(?Personne $editeur): self
    {
        $this->editeur = $editeur;

        return $this;
    }
}

templates/base.html.twig
<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <title>{% block title %}Legifail{% endblock %}</title>
    {% block stylesheets %}
        <link rel="stylesheet" href="{{ asset('/css/global.css') }}" />
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-giJF6kkoqNQ00vy+HMDP7azOuL0xtbfIcaT9wjKHr8RbDVddVHyTfAAsrekwKmP1" crossorigin="anonymous">
    {% endblock %}
</head>
<body>
<div class="container-fluid">
    <div class="row">
        <div class="col-md-12" id="mainnav">
            <nav class="container navbar navbar-expand-lg static-top">
                <div class="navbar-header">
                    <a class="navbar-brand" href="{{ path('index') }}">
                        <img src="http://panel.failyv.com/assets/images/logo/failyv-dashboard-logo.png" width="30" height="30" class="d-inline-block align-top" alt="">
                        <span id="site_title">LegiFail</span>
                    </a>
                </div>

                <ul class="navbar-nav ml-auto">
                    <form class="form-inline my-2 my-lg-0">
                        {% if not is_granted('IS_AUTHENTICATED_FULLY') %}
                            <a class="icon-navbar btn btn-light" href="{{ path('login') }}">Connexion</a>
                        {% endif %}
                        {% if is_granted('IS_AUTHENTICATED_FULLY') %}
                            <a class="icon-navbar btn btn-dark" href="{{ path('logout') }}">Déconnexion</a>
                        {% endif %}
                        {% if is_granted('ROLE_USER') %}
                            <a class="icon-navbar btn btn-success" href="{{ path('nouveauDecret') }}">Ajouter décret</a>
                            {% if is_granted('ROLE_ADMIN') %}
                                <a class="icon-navbar btn btn-danger" href="{{ path('nouvelleInstance') }}">Ajouter instance</a>
                                <a class="icon-navbar btn btn-danger" href="{{ path('nouvellePersonne') }}">Ajouter personne</a>
                            {% endif %}
                        {% endif %}
                    </form>
                </ul>
            </nav>
        </div>
    </div>
</div>
<div id="page_title" class="col-md-12 d-inline-block">
    {% block pageTitle %}
        <h1>Rechercher un décret</h1>
    {% endblock %}

</div>
{% block actions %}
{% endblock %}
<div class="container-fluid">

    <div class="container">
        <div class="row">

            <div class="col-md-12">
                {% block body %}
{#                    <h2>Effectuer une recherche</h2>#}
{#                    <form>#}
{#                        <div class="form-group">#}
{#                            <label for="search">Rechercher</label>#}
{#                            <input type="text" class="form-control" id="search" placeholder="Code pénal, Robin des bois ...">#}
{#                        </div>#}
{#                        <div class="form-group">#}
{#                            <label for="tag">Catégorie</label>#}
{#                            <select id="tag" class="form-control">#}
{#                                <option selected>Catégorie</option>#}
{#                                <option>Décrets</option>#}
{#                                <option>Lois fédérales</option>#}
{#                            </select>#}
{#                        </div>#}
{#                        <button type="submit" class="btn btn-primary">Rechercher</button>#}
{#                    </form>#}
                    <h2>Liste des décrets en vigueur</h2>
                    {% for decret in decrets %}
                        <li><a href="{{ path('decret', {'id' : decret.id}) }}">{{ decret.titre }}</a> </li>
                    {% endfor %}

                {% endblock %}
            </div>
        </div>
    </div>

    <footer class="page-footer font-small fixed-bottom">

        <!-- Copyright -->
        <div class="footer-copyright text-center py-3">Version 0.1.3.0 | © 2021 Copyright:
            <a href="https://panel.failyv.com"> Kezhan</a>
        </div>
        <!-- Copyright -->

    </footer>
    {% block javascripts %}{% endblock %}
</div>
</body>
</html>

templates/decret.html.twig
{% extends "base.html.twig" %}

{% block pageTitle %}
    <h1>{{ decret.titre }}</h1>
{% endblock %}

{% block actions %}
    <div id="interactions">
        <div class="container">
            <div class="row">
                <div class="btn-group" role="group" aria-label="Basic outlined example">
                    <a type="button" class="btn btn-outline-warning" href="{{ path('modifierDecret', {'id' : decret.id}) }}">Editer</a>
                    <a type="button" class="btn btn-outline-danger">Supprimer</a>
                    <a type="button" class="btn btn-outline-info" href="{{ path('pdf', {'id' : decret.id}) }}">Imprimer</a>
                </div>
            </div>
        </div>
    </div>
{% endblock %}


{% block body %}
    <div class="row" id="main">
        <div class="col-md-12">
            {% if decret.dateClose != null and decret.actif == 'S'%}
                <span class="badge bg-danger">Supprimé le : {{ decret.dateclose|date("d/m/Y") }} {{ decret.editeur.nom }}</span>
            {% endif %}
            <span class="badge bg-primary">Publié le : {{ decret.dateinsert|date("d/m/Y") }} par {{ decret.auteur.nom }}</span>
            {% if decret.dateUpdate != null and decret.dateClose == null %}
            <span class="badge bg-warning">Modifié le : {{ decret.dateupdate|date("d/m/Y") }} par {{ decret.editeur.nom }}</span>
            {% endif %}
            <span class="badge bg-success">Entrée en application le : {{ decret.dateapply|date("d/m/Y") }}</span>
            <p>{{ decret.idInstance.nom }}</p>
            {% if decret.actif == 'S' %}
                <h2 class="alert-danger">Attention, de décret a été supprimé et n'est plus en application. Aucun élément présent dans ce texte ne peut
                être pris en compte.</h2>
            {% endif %}
            <hr style="width: 100%; color: black; height: 1px; background-color:black;" />
            {{ decret.contenu|raw }}
        </div>
    </div>

{% endblock %}

templates/decretAjouter.html.twig
{% extends "base.html.twig" %}

{% block pageTitle %}
    <h1>Ajouter un décret</h1>
{% endblock %}


{% block actions %}

{% endblock %}


{% block body %}
    <br />
    {{ form_start(form) }}
    <form>
        <div class="form-group">
            {{ form_label(form.titre, 'Titre du décret') }}
            {{ form_widget(form.titre, {'attr': {'class': 'form-control', 'placeholder' : 'Décret Robin des Bois' }}) }}
        </div>
        <br />
        <div class="form-group">
            {{ form_label(form.contenu, 'Texte du décret') }}
            {{ form_widget(form.contenu, {'attr': {'class': 'form-control'}}) }}
        </div>
        <br />
        <div class="form-group">
            {{ form_label(form.actif, 'Etat de décret') }}
            {{ form_widget(form.actif, {'attr': {'class': 'form-control', 'placeholder' : 'P = Préparation, A = Actif, S=Supprimé' }}) }}
        </div>
        <br />
        <div class="form-group">
            {{ form_row(form.save, { 'label': 'Ajouter', 'attr' : {'class' : 'btn btn-success'} }) }}
        </div>
        <br />
        {{ form_rest(form) }}
    </form>
    {{ form_errors(form) }}
    {{ form_end(form) }}
{#    {{ form(form) }}#}

{% endblock %}

templates/decretModifier.html.twig
{% extends "base.html.twig" %}

{% block pageTitle %}
    <h1>Modifier un décret</h1>
{% endblock %}


{% block actions %}

{% endblock %}


{% block body %}
    <br />
    {{ form_start(form) }}
    <form>
        <div class="form-group">
            {{ form_label(form.titre, 'Titre du décret') }}
            {{ form_widget(form.titre, {'attr': {'class': 'form-control', 'placeholder' : 'Décret Robin des Bois' }}) }}
        </div>
        <br />
        <div class="form-group">
            {{ form_label(form.contenu, 'Texte du décret') }}
            {{ form_widget(form.contenu, {'attr': {'class': 'form-control'}}) }}
        </div>
        <br />
        <div class="form-group">
            {{ form_label(form.actif, 'Etat de décret') }}
            {{ form_widget(form.actif, {'attr': {'class': 'form-control'}}) }}
        </div>
        <br />
        <div class="form-group">
            {{ form_row(form.save, { 'label': 'Ajouter', 'attr' : {'class' : 'btn btn-success'} }) }}
        </div>
        <br />
        {{ form_rest(form) }}
    </form>
    {{ form_errors(form) }}
    {{ form_end(form) }}
{#    {{ form(form) }}#}

{% endblock %}

templates/decretpdf.html.twig
<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <title>Décret | {{ decret.titre }}</title>
    <link rel="stylesheet" href="{{ asset('/css/pdf.css') }}" />
</head>
<body>
<div style="text-align: center">
    {% if decret.idInstance.logo == 'GOUV' %}
        <img src="https://static.wikia.nocookie.net/failyv/images/d/d3/Seal_Of_GovernorV2_2.png/revision/latest/scale-to-width-down/620?cb=20190127152330&path-prefix=fr" width="20%"
    {% endif %}
    {% if decret.idInstance.logo == 'MAIRIE_LS' %}
        <img src="https://static.wikia.nocookie.net/failyv/images/d/d3/Seal_Of_GovernorV2_2.png/revision/latest/scale-to-width-down/620?cb=20190127152330&path-prefix=fr" width="20%"
    {% endif %}
    {% if decret.idInstance.logo == 'MAIRIE_BC' %}
        <img src="https://static.wikia.nocookie.net/failyv/images/d/d3/Seal_Of_GovernorV2_2.png/revision/latest/scale-to-width-down/620?cb=20190127152330&path-prefix=fr" width="20%"
    {% endif %}
</div>
<h1 style="text-align: center; text-transform: uppercase">{{ decret.titre }}</h1>
<div style="text-align: center;border: solid 1px black;">
        <h2>{{ decret.idInstance.nom }}</h2>
            Entrée en vigueur : {{ decret.dateApply|date("d/m/Y") }}
            {% if decret.actif == 'P' %}
                <p>Décret en préparation</p>
            {% elseif decret.actif == 'S' %}
                <p>Décret supprimé</p>
            {% endif %}
            {% if decret.dateUpdate != null %}
                <p>Dernière modification : {{ decret.dateUpdate|date("d/m/Y") }}</p>
            {% endif %}
</div>

{{ decret.contenu|raw }}
</body>
</html>

templates/instanceAjouter.html.twig
{% extends "base.html.twig" %}

{% block pageTitle %}
    <h1>Ajouter une instance</h1>
{% endblock %}


{% block actions %}

{% endblock %}


{% block body %}
    <br />
    {{ form_start(form) }}
    <form>
        <div class="form-group">
            {{ form_label(form.nom, 'Nom de l\'instance') }}
            {{ form_widget(form.nom, {'attr': {'class': 'form-control', 'placeholder' : 'Gouvernement de San Andreas' }}) }}
        </div>
        <br />
        <div class="form-group">
            {{ form_label(form.logo, 'Logo') }}
            {{ form_widget(form.logo, {'attr': {'class': 'form-control'}} ) }}
        </div>
        <br />
        <div class="form-group">
            {{ form_row(form.save, { 'label': 'Ajouter', 'attr' : {'class' : 'btn btn-success'} }) }}
        </div>
        <br />
        {{ form_rest(form) }}
    </form>
    {{ form_errors(form) }}
    {{ form_end(form) }}
{#    {{ form(form) }}#}

{% endblock %}

templates/login.html.twig
{% extends "base.html.twig" %}

{% block pageTitle %}
    <h1>Connexion</h1>
{% endblock %}

{% block actions %}
    <div id="interactions">
        <div class="container">
            <div class="row">
                </div>
            </div>
        </div>
    </div>
{% endblock %}


{% block body %}
    <br />
    <div class="row justify-content-md-center p-3 mb-2 bg-dark.bg-gradient"  id="main">
        <div class="col-md-4">
            {% if error %}
                <div>{{ error.messageKey|trans(error.messageData, 'security') }}</div>
            {% endif %}

            <form action="{{ path('login') }}" method="post">
                <div class="form-group">
                    <label for="username">Nom d'utilisateur :</label>
                    <input type="text" id="username" name="_username" value="{{ last_username }}" class="form-control" placeholder="Prénom Nom"/>
                </div>
                <br />
                <div class="form-group">
                    <label for="password">Mot de passe :</label>
                    <input type="password" id="password" name="_password" class="form-control" placeholder="Mot de passe"/>
                </div>
                <br />
                <div class="form-group" align="center">
                    <button class="btn btn-success align-items-center" type="submit">Connexion</button>
                </div>
            </form>
        </div>
    </div>

{% endblock %}

templates/personneAjouter.html.twig
{% extends "base.html.twig" %}

{% block pageTitle %}
    <h1>Ajouter un décret</h1>
{% endblock %}


{% block actions %}

{% endblock %}


{% block body %}
    <br />
    {{ form_start(form) }}
    <form>
        <div class="form-group">
            {{ form_label(form.nom, 'Prénom Nom') }}
            {{ form_widget(form.nom, {'attr': {'class': 'form-control', 'placeholder' : 'Elon Musk' }}) }}
        </div>
        <br />
        <div class="form-group">
            {{ form_label(form.password, 'Mot de passe') }}
            {{ form_widget(form.password, {'attr': {'class': 'form-control'}}) }}
        </div>
        <br />
        <div class="form-group">
            {{ form_label(form.instance, 'Instance') }}
            {{ form_widget(form.instance, {'attr': {'class': 'form-control'}}) }}
        </div>
        <br />
        <div class="form-group">
            {{ form_label(form.date_elect, 'Début du mandat') }}
            {{ form_widget(form.date_elect, {'attr': {'class': 'form-control'}}) }}
        </div>
        <br />
        <div class="form-group">
            {{ form_row(form.save, { 'label': 'Ajouter', 'attr' : {'class' : 'btn btn-success'} }) }}
        </div>
        <br />
        {{ form_rest(form) }}
    </form>
    {{ form_errors(form) }}
    {{ form_end(form) }}
{#    {{ form(form) }}#}

{% endblock %}